(de operandprintforeignentry (x)
  (prog (!*lower symnamx)
        (setq symnamx (symnam (id2int (cadr x))))
        (setq !*lower t)
	(prin2 "_")
        (prin2 (cadr x))))

(de *foreignlink (functionname functiontype numberofarguments)

   (let ((sequence nil))
     (setq sequence
	(append 
        `((L (reg r15) (lit ,(bldmsg "    DC   V(%w)" functionname)))
	  (*move (reg r3) (reg r10)))
                 (cond ((equal numberofarguments 0) nil)
                       (t (pnth '((*move (reg 5) (reg r4))
                                  (*move (reg 4) (reg r3))
                                  (*move (reg 3) (reg r2))
                                  (*move (reg 2) (reg r1))
                                  (*move (reg 1) (reg r0)))
                                 (difference 6  numberofarguments))))))
     (setq sequence
         (append sequence
            `((*wshift (reg st) -3)
              (*wshift (reg st)  3)  % double word alignment of st
              (BALR (reg r14) (reg r15)))))
     (setq sequence
         (append sequence
                    '((*move (reg r0) (reg 1))   %store return value in r1
		      (*move (reg r10) (reg r3)) %restore base register
                     )))))

(tr *foreignlink)
(flag1 '*foreignlink 'lose)

(de kurzid (id) (prog (exp *lower *raise)
		(setq *lower t)
                (setq exp (explode2 id))
                (when (and (eq (car exp) '!u) (eq (cadr exp) '!n)
                           (eq (caddr exp) '!i) (eq (cadddr exp) '!x))
                        (setq exp (cons '!u (cddddr exp))))
                (when (and (eq (car exp) '!o) (eq (cadr exp) '!l)
                           (eq (caddr exp) '!d) )
                        (setq exp (cons '!o (cdddr exp))))
                (when (and (eq (car exp) '!e) (eq (cadr exp) '!x)
                                (greaterp (length exp) 9)
                           (eq (caddr exp) '!t)(eq (caddDr exp) '!e) )
                        (setq exp (cons '!e (pnth exp 9))))
		(off raise)
                (return (intern (compress (cons '!_ exp)))))))

(flag1 'kurzid 'lose)

(defcmacro *ALLOC
        ((Freep) (using "*" (reg r15)))
        (       (STM (Reg r2) (reg r15) (displacement (reg r13) 16))
                (*move (plus2 80 ArgOne) (reg r0))
                (LR (reg r12) (reg r13))
                (sLR (reg r13) (reg r0))
                (st  (reg r12)  (displacement (reg r13) 4))
                (Balr (reg r3) (reg r0))
                (Using "*" (reg r3) (reg r2))
% should be optimize some day
                (la (reg r2) (displacement (reg r3) 2048))
                (la (reg r2) (displacement (reg r2) 2048))))

(DefCMacro *DeAlloc
         ((FreeP))
         (     (L  (reg r13) (displacement (reg r13) 4))
                (LM (reg r2) (reg r14) (displacement (reg r13) 16))))


