%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXU:GET-OPTIONS.SL
% Description:  Get command line arguments (VAX UNIX version)
% Author:       Cris Perdue
% Created:      April 5, 1983
% Modified:     13-Jan-84 10:09:43 (Brian Beach)
% Package:	
%
% (c) Copyright 1987, University of Utah, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 02-Nov-89 (Kessler)
%  Not using map file any more, reset to 1.
% 08-Oct-87 (Kessler)
% Changed to ignore the first 3, since map and map file are always there.
% 13-Jan-84 10:08:44 (Brian Beach)
%  Added standard header.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(de get-command-args ()
  (getunixargs)
  (for (from i 1 (size Unixargs*))	% Don't return the zeroeth /csp
       (collect (indx UnixArgs* i))))

%% End of File.
