%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXU:GET-OPTIONS.SL
% Description:  Get command line arguments (VAX UNIX version)
% Author:       Cris Perdue
% Created:      April 5, 1983
% Modified:     05-Oct-87 (Harold Carr)
% Package:	
%
% (c) Copyright 1987, University of Utah, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
(de get-command-args ()
 (let ((ii 1))
  (for (from i 1 (size Unixargs*))
    (do
     (if (member (indx UnixArgs* i) '("-t" "-td" "-tx" "-f"))
         (setq ii (wplus2 ii 2)) )))
  (for (from i ii (size Unixargs*))     % Don't return the zeroeth /csp
       (collect (indx UnixArgs* i)))))

