%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXU:GET-OPTIONS.SL
% Description:  Get command line arguments
% Author:       Cris Perdue
% Created:      April 5, 1983
% Modified:     13-Jan-84 10:09:43 (Brian Beach)
%
% (c) Copyright 1987, University of Utah, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 13-Jan-84 10:08:44 (Brian Beach)
%  Added standard header.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(de get-command-args ()
 (let ((ii 1))
  (for (from i 1 (size Unixargs*))
    (do
     (if (member (indx UnixArgs* i) '("-t" "-td" "-tx" "-f")) 
         (setq ii (wplus2 ii 2)) )))
  (for (from i ii (size Unixargs*))	% Don't return the zeroeth /csp
       (collect (indx UnixArgs* i)))))
